<div>
    <div id="subheader">
        <div class="item">
            <dx-tabs #navbarTabs [height]="ds.tabsHeight" [width]="ds.tabsWidth" (onInitialized)="onInitTabs($event)" [dataSource]="subnavTabs" [scrollingEnabled]="true" [scrollByContent]="true"
                [showNavButtons]="true" [selectedIndex]="0" (onItemClick)="reloadData($event)"></dx-tabs>
        </div>
    </div>
    <br/>

    <dx-data-grid class="gridContainer" [class.isMob]="ds.isMob" #gridTrips [columnAutoWidth]='true' [allowColumnResizing]='true' [allowColumnReordering]='true'
        [rowAlternationEnabled]='ds.rowAlternationEnabled' [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'
        [dataSource]='dsTrips' [height]='ds.customHeight' [customizeColumns]='customizeColumns' (onToolbarPreparing)='toolbarPreparing($event, true)'
        (onRowPrepared)="onRowTripPrepared($event)" (onSelectionChanged)="onSelectionChTrip($event)">

        <dxo-editing [allowAdding]='false'></dxo-editing>
        <dxo-export [enabled]='true' fileName='orders'></dxo-export>
        <dxo-header-filter [visible]='true'></dxo-header-filter>
        <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
        <dxo-search-panel [visible]='true'></dxo-search-panel>
        <dxo-filter-row [visible]='true'> </dxo-filter-row>
        <dxo-column-chooser [enabled]='true'></dxo-column-chooser>
        <dxo-state-storing [enabled]='true' [storageKey]='"gridTripsWST" + current' type="custom" [customLoad]="ds.gridLoadState" [customSave]="ds.gridSaveState"></dxo-state-storing>
        <dxo-master-detail [enabled]='true' template='detail'></dxo-master-detail>
        <dxo-remote-operations [filtering]="true" [sorting]="true" [paging]="true"></dxo-remote-operations>
        <dxo-selection [mode]="current == 'ap' ? 'multiple' : 'none'" showCheckBoxesMode='always'></dxo-selection>

        <dxi-column caption='Ref Number' cellTemplate='tripColumn' dataField='t_refNumber' dataType='number' width='60' fixedPosition='left'
            [allowResizing]='false' [showInColumnChooser]='false' [allowHeaderFiltering]='false'>
            <div *dxTemplate="let row of 'tripColumn'">
                <a class="dx-link" (click)="editTrip(row)"> {{ row.data.t_refNumber }}</a>
            </div>
        </dxi-column>
        <dxi-column caption='Depot' dataField='d_name' dataType='string'></dxi-column>
        <dxi-column caption='Transporter' dataField='tr_name' dataType='string'></dxi-column>
        <dxi-column caption='Truck' dataField='c_registrationNo' dataType='string'></dxi-column>
        <dxi-column caption='Trailer' dataField='tk_registrationNo' dataType='string'></dxi-column>
        <dxi-column caption='Trip NO' dataField='t_orderIndex' cellTemplate='position' dataType='number' [allowResizing]='false' width='60' [showInColumnChooser]='false'>
            <div *dxTemplate="let row of 'position'" style="text-align:right;">
                <span>{{ row.data.t_orderIndex }}</span>
                <div class="dx-icon dx-icon-arrowup" (click)="changeTripOrder(row.data, true)" *ngIf='!ds.isSales()'></div>
                <div class="dx-icon dx-icon-arrowdown" (click)="changeTripOrder(row.data, false)" *ngIf='!ds.isSales()'></div>
            </div>
        </dxi-column>

        <dxi-column caption='Driver' dataField='driver' dataType='string'></dxi-column>
        <dxi-column caption='Loading Date' dataField='t_plannedDate' dataType='date' calculateSortValue='t_plannedDate' [calculateDisplayValue]='ds.getDateTime'></dxi-column>
        <dxi-column caption='Start Date' dataField='t_startDate' dataType='date' calculateSortValue='t_startDate' [calculateDisplayValue]='ds.getDateTime'></dxi-column>
        <dxi-column caption='Last KM' dataField='t_lastKm' dataType='number'></dxi-column>
        <dxi-column caption='Estimated Km' dataField='t_estimatedKm' dataType='number'></dxi-column>
        <dxi-column caption='Estimated Date' dataField='t_estimatedDate' dataType='date' calculateSortValue='t_estimatedDate' [calculateDisplayValue]='ds.getDateTime'></dxi-column>
        <dxi-column caption='Comments' dataField='t_comments' dataType='string'></dxi-column>
        <dxi-column cellTemplate='actions' fixedPosition='right' [fixed]='true' [allowResizing]='false' width='100px' [showInColumnChooser]='false'
            [visible]="current !== 'pg' && current !== 'fin' && (!ds.isTrans() || current == 'new' || current =='ap') && !ds.isSales()">
            <div *dxTemplate="let data of 'actions'" id="actionsColumn">
                <dx-button class="dx-success" (click)="changeTripStatus(1, data)" icon='check' hint='Send to approve' height='14' *ngIf='current === "new"'></dx-button>
                <dx-button class="dx-success" (click)="changeTripStatus(2, data)" icon='check' hint='Approve' height='14' *ngIf='!ds.isTrans() && current === "pn"'></dx-button>
                <dx-button class="dx-success" (click)="changeTripStatus(3, data)" icon='runner' hint='Send to SAP' height='14' *ngIf='!ds.isTrans() && current === "ap"'></dx-button>
                <dx-button class="dx-success" (click)="changeTripStatus(3, data)" icon='chevronprev' hint='Send back to Edit' height='14' *ngIf='ds.isSuperAdmin() && current === "sts" && data.data.t_statusId == 4'></dx-button>
                <dx-button class="dx-success" (click)="changeTripStatus(0, data)" [icon]="data.data.t_statusId === 2 && data.data.t_comments ? 'revert': 'remove'"
                    [hint]="data.data.t_statusId === 2 && data.data.t_comments ? 'Return to new': 'Reject'" height='14' *ngIf='!ds.isTrans() && data.data.t_statusId != 4 && (current === "pn" || current === "ap")'></dx-button>
                <dx-button class="dx-success" (click)="changeTripStatus(0, data)" icon='revert' hint='Request review' height='14' *ngIf='ds.isTrans() && current === "ap"'></dx-button>
                <dx-button class="dx-success" (click)="changeTripStatus(0, data)" icon="revert" hint="Return to new" height='14' *ngIf='!ds.isTrans() && data.data.t_statusId != 4 && current === "sts"'></dx-button>
                <dx-button class="dx-success" (click)="changeTripStatus(-2, data)" icon='trash' hint='Delete' height='14' *ngIf='(!ds.isTrans() && data.data.t_statusId != 4 && (current === "sts" || current === "ap")) || current === "new" || current === "pn"'></dx-button>
            </div>
        </dxi-column>
        <div *dxTemplate="let c of 'detail'">
            <dx-data-grid [columnAutoWidth]='true' [height]='300' [rowAlternationEnabled]='false' [showColumnLines]='ds.showColumnLines'
                [showRowLines]='ds.showRowLines' (onContentReady)='orderInit($event, c)' (onCellPrepared)='onCellPrepared($event, c)' 
                (onToolbarPreparing)='toolbarPreparing($event, false)' (onRowPrepared)="onRowOrderPrepared($event)">
                
                <dxo-export [enabled]='true' fileName='orders'></dxo-export>
                <dxo-search-panel [visible]='true'></dxo-search-panel>
                <dxo-filter-row [visible]='false'> </dxo-filter-row>
                <dxo-column-chooser [enabled]='true'></dxo-column-chooser>
                <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
                <dxo-sorting mode='none'></dxo-sorting>
                
                <dxi-column cellTemplate='position' fixedPosition='left' [fixed]='true' [allowResizing]='false' width='50' [showInColumnChooser]='false'
                    [visible]="(current === 'ap' || current === 'new' || current === 'pn') && !ds.isSales()">
                    <div *dxTemplate="let row of 'position'" style="text-align:center;">
                        <div class="dx-icon dx-icon-arrowup" (click)="changeOrder(row.data, true)" *ngIf='row.rowIndex > 0'>
                        </div>
                        <div class="dx-icon dx-icon-arrowdown" (click)="changeOrder(row.data, false)" *ngIf='row.rowIndex < row.component.totalCount() - 1'>
                        </div>
                    </div>
                </dxi-column>

                <dxi-column caption='SO Number' dataField='ol_refNumber' dataType='number' [allowHeaderFiltering]='false'></dxi-column>
                <dxi-column caption='Customer Code' dataField='c_code' dataType='string'></dxi-column>
                <dxi-column caption='Customer' dataField='c_name' dataType='string' [allowHeaderFiltering]='false'></dxi-column>
                <dxi-column caption='Ship to Party' dataField='ca_code' dataType='string'></dxi-column>
                <dxi-column caption='County' dataField='ca_region' dataType='string'></dxi-column>
                <dxi-column caption='City' dataField='ca_city' dataType='string'></dxi-column>
                <dxi-column caption='Requested Date' dataField='ol_requestDate' dataType='date' calculateSortValue='fromDate' [calculateDisplayValue]='ds.getDate'></dxi-column>
                <dxi-column caption='Product' dataField='p_name' dataType='string'></dxi-column>
                <dxi-column caption='Product code' dataField='p_code' dataType='string'></dxi-column>
                <dxi-column caption='Ordered Quantity L15' dataField='ol_quantity' dataType='number' [allowHeaderFiltering]='false'></dxi-column>
                <dxi-column caption='Loaded Quantity L15' dataField='ol_loadedQuantity' dataType='number' [allowHeaderFiltering]='false'></dxi-column>
                <dxi-column caption='Delivered Quantity L15' dataField='ol_deliveredQuantity' dataType='number' [allowHeaderFiltering]='false' [allowEditing]="false"></dxi-column>
                <dxi-column caption='Delivery Date' dataField='ol_deliveryDate' dataType='datetime' [calculateDisplayValue]='ds.getDateTime' [allowEditing]="false"></dxi-column>
                <dxi-column caption='Estimated Km' dataField='ol_estimatedKm' dataType='number' [allowHeaderFiltering]='false'></dxi-column>
                <dxi-column caption='Address' dataField='ca_description' dataType='string' [allowHeaderFiltering]='false'></dxi-column>

                <dxi-column cellTemplate='delete' fixedPosition='right' [fixed]='true' [allowResizing]='false' width='25' [showInColumnChooser]='false'
                    [visible]="(current === 'new' || current === 'pn') && !ds.isSales()">
                    <div *dxTemplate="let row of 'delete'">
                        <div class="dx-icon dx-icon-trash" (click)="deleteOrder(row.data)"></div>
                    </div>
                </dxi-column>
                <dxo-summary [calculateCustomSummary]="calculateSummary">
                    <dxi-total-item column="ol_refNumber" summaryType="count"></dxi-total-item>
                    <dxi-total-item column="ol_quantity" summaryType="sum" [customizeText]="customLoadedQuant"></dxi-total-item>
                    <dxi-total-item column="ol_quantity" summaryType="custom" name="availableQuantSummary" [customizeText]="customAvailableQuant"></dxi-total-item>
                </dxo-summary>
            </dx-data-grid>
        </div>
    </dx-data-grid>
</div>

<dx-popup [(visible)]="isRejectVisible" width='auto' height='auto' [position]="ds.popupPosition" titleTemplate="popupTitle" contentTemplate="popupContent">
    <div *dxTemplate="let item of 'popupTitle'">
        <div class="logo-small" style="float:left">
            <img src="assets/img/Logo1.png" style="width:25px; height:25px; display:block;" />
        </div>
        <h4>Trip Number: {{ pt.refNumber }}</h4>
    </div>
    <div *dxTemplate="let item of 'popupContent'">
        <dx-form [formData]='pt'>
            <dxi-item itemType="group" [caption]="'Do you want to ' + (ds.isTrans() ? 'request a modification for' : 'reject') + ' this trip ?'">
                <dxi-item [label]="{text: 'Comments'}" dataField="comments" editorType="dxTextArea" [editorOptions]="{ height: 50, width: 300 }"></dxi-item>
            </dxi-item>
        </dx-form>
        <div style="float: right;margin-bottom:20px;">
            <dx-button [text]="ds.isTrans() ? 'Request' : 'Reject'" (onClick)='rejectClick()' type='success'></dx-button>
            <dx-button text='Cancel' (onClick)='cancelClick()' class='redTxt'></dx-button>
        </div>
    </div>
</dx-popup>

<dx-popup title='Trip' [(visible)]='isTripVisible' width='auto' height='auto' position='top'>
    <div *dxTemplate="let data of 'title'">
        <div class="logo-small" style="float:left">
            <img src="assets/img/Logo1.png" style="width:25px; height:25px; display:block;" />
        </div>
        <h4>Create new trip</h4>
    </div>
    <div *dxTemplate="let data of 'content'">
        <dx-form [colCount]="1" [formData]='t' [showValidationSummary]="false" validationGroup="tripValidation">
            <dxi-item itemType="group" [colSpan]="1" [colCount]='1'>
                <dxi-item [label]="{text: 'Transporter'}" dataField="transporterId" editorType="dxSelectBox" [editorOptions]="{ dataSource: dsTransporter, valueExpr: 'id', displayExpr: 'name', disabled: t.disbleTransp, onValueChanged: onTransporterCh }">
                    <dxi-validation-rule type="required"></dxi-validation-rule>
                </dxi-item>
                <dxi-item [label]="{text: 'Depot'}" dataField="depotId" editorType="dxSelectBox" [editorOptions]="{ dataSource: dsDepot, valueExpr: 'id', displayExpr: 'name' }">
                    <dxi-validation-rule type="required"></dxi-validation-rule>
                </dxi-item>
                <dxi-item [label]="{text: 'Loading Date'}" dataField="plannedDate" editorType="dxDateBox" [editorOptions]="{ type:'datetime', displayFormat: 'dd.MM.yyyy HH:mm', width:'100%' }">
                    <dxi-validation-rule type="required"></dxi-validation-rule>
                </dxi-item>
                <dxi-item [label]="{text: 'Truck'}" dataField="carId" editorType="dxSelectBox" [editorOptions]="{ dataSource: dsTruck, valueExpr: 'id', displayExpr: 'registrationNo', searchEnabled: 'true', onValueChanged: onSelectTruck }">
                    <dxi-validation-rule type="required"></dxi-validation-rule>
                </dxi-item>
                <dxi-item [label]="{text: 'Trailer'}" dataField="tankId" editorType="dxSelectBox" [editorOptions]="{ dataSource: dsTank, valueExpr: 'id', displayExpr: 'registrationNo', searchEnabled: 'true' }">
                    <dxi-validation-rule type="required"></dxi-validation-rule>
                </dxi-item>
                <dxi-item [label]="{text: 'Driver'}" dataField="driverId" editorType="dxLookup" [editorOptions]="{ dataSource: dsDrivers, valueExpr: 'id', pagingEnabled: false, displayExpr: displayDriver, closeOnOutsideClick:true, searchExpr: ['firstName', 'lastName'] }">
                    <dxi-validation-rule type="required"></dxi-validation-rule>
                </dxi-item>
            </dxi-item>
        </dx-form>
        <br/>
        <div style="float: right;margin-bottom:20px;">
            <dx-button type='success' text='Save' (onClick)='onSaveTrip($event)' validationGroup="tripValidation"></dx-button>
            <dx-button class='redTxt' text='Cancel' (onClick)='cancelClick($event)'></dx-button>
        </div>
    </div>
</dx-popup>